clang 8.0.0

Public Member Functions | Static Public Member Functions | List of all members
clang::threadSafety::til::Literal Class Reference

`#include "clang/Analysis/Analyses/ThreadSafetyTIL.h"`

Inheritance diagram for clang::threadSafety::til::Literal:
[legend]
Collaboration diagram for clang::threadSafety::til::Literal:
[legend]

## Public Member Functions
| Literal (const Expr *C)
| Literal (ValueType VT)
| Literal (const Literal &)=default
const Expr * | clangExpr () const
ValueType | valueType () const
template<class T >
const LiteralT< T > & | as () const
template<class T >
LiteralT< T > & | as ()
template<class V >
V::R_SExpr | traverse (V &Vs, typename V::R_Ctx Ctx)
template<class C >
C::CType | compare (const Literal *E, C &Cmp) const
Public Member Functions inherited from clang::threadSafety::til::SExpr
| SExpr ()=delete
TIL_Opcode | opcode () const
void * | operator new (size_t S, MemRegionRef &R)
void * | operator new (size_t)=delete
| SExpr objects must be created in an arena. More...
void | operator delete (void *)=delete
| SExpr objects cannot be deleted. More...
unsigned | id () const
| Returns the instruction ID for this expression. More...
BasicBlock * | block () const
| Returns the block, if this is an instruction in a basic block, otherwise returns null. More...
void | setID (BasicBlock *B, unsigned id)
| Set the basic block and instruction ID for this expression. More...

## Static Public Member Functions
static bool | classof (const SExpr *E)

## Additional Inherited Members
Protected Member Functions inherited from clang::threadSafety::til::SExpr
| SExpr (TIL_Opcode Op)
| SExpr (const SExpr &E)
Protected Attributes inherited from clang::threadSafety::til::SExpr
const unsigned char | Opcode
unsigned char | Reserved = 0
unsigned short | Flags = 0
unsigned | SExprID = 0
BasicBlock * | Block = nullptr

## Detailed Description

Definition at line 530 of file ThreadSafetyTIL.h.

## Constructor & Destructor Documentation

## ◆ Literal() [1/3]

clang::threadSafety::til::Literal::Literal | ( | const Expr * | C | ) |
| inline

Definition at line 532 of file ThreadSafetyTIL.h.

## ◆ Literal() [2/3]

clang::threadSafety::til::Literal::Literal | ( | ValueType | VT | ) |
| inline

Definition at line 534 of file ThreadSafetyTIL.h.

## ◆ Literal() [3/3]

clang::threadSafety::til::Literal::Literal | ( | const Literal & |  | ) |
| default

## Member Function Documentation

## ◆ as() [1/2]

template<class T >

const LiteralT<T>& clang::threadSafety::til::Literal::as | ( |  | ) | const
| inline

Definition at line 544 of file ThreadSafetyTIL.h.

Referenced by clang::threadSafety::til::PrettyPrinter< StdPrinter, std::ostream >::printLiteral().

## ◆ as() [2/2]

template<class T >

LiteralT<T>& clang::threadSafety::til::Literal::as | ( |  | ) |
| inline

Definition at line 547 of file ThreadSafetyTIL.h.

## ◆ clangExpr()

const Expr* clang::threadSafety::til::Literal::clangExpr | ( |  | ) | const
| inline

Definition at line 540 of file ThreadSafetyTIL.h.

Referenced by clang::threadSafety::til::PrettyPrinter< StdPrinter, std::ostream >::printLiteral().

## ◆ classof()

static bool clang::threadSafety::til::Literal::classof | ( | const SExpr * | E | ) |
| inline static

Definition at line 537 of file ThreadSafetyTIL.h.

References clang::threadSafety::til::SExpr::opcode().

## ◆ compare()

template<class C >

C::CType clang::threadSafety::til::Literal::compare | ( | const Literal * | E,
|  | C & | Cmp
| ) |  | const
| inline

Definition at line 554 of file ThreadSafetyTIL.h.

## ◆ traverse()

template<class V >

V::R_SExpr clang::threadSafety::til::Literal::traverse | ( | V & | Vs,
|  | typename V::R_Ctx | Ctx
| ) |  |

Definition at line 579 of file ThreadSafetyTIL.h.

References clang::threadSafety::til::ValueType::BT_Bool, clang::threadSafety::til::ValueType::BT_Float, clang::threadSafety::til::ValueType::BT_Int, clang::threadSafety::til::ValueType::BT_Pointer, clang::threadSafety::til::ValueType::BT_String, clang::threadSafety::til::ValueType::BT_ValueRef, clang::threadSafety::til::ValueType::BT_Void, clang::threadSafety::til::ValueType::ST_16, clang::threadSafety::til::ValueType::ST_32, clang::threadSafety::til::ValueType::ST_64, and clang::threadSafety::til::ValueType::ST_8.

## ◆ valueType()

ValueType clang::threadSafety::til::Literal::valueType | ( |  | ) | const
| inline

Definition at line 542 of file ThreadSafetyTIL.h.

Referenced by clang::threadSafety::til::PrettyPrinter< StdPrinter, std::ostream >::printLiteral().

The documentation for this class was generated from the following file:

- include/clang/Analysis/Analyses/ThreadSafetyTIL.h